//+------------------------------------------------------------------+
//|                                                       %r nrp.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum    -100
#property indicator_maximum    0
#property indicator_buffers    5
#property indicator_color1     MediumOrchid
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_levelcolor Gold

//
//
//
//
//

extern int    WprPeriod                = 50;
extern double levelOb                  = -20;
extern double levelOs                  = -80;
extern bool   MultiColored             = true;
extern color  OverSoldColor            = DeepSkyBlue; 
extern color  OverBoughtColor          = Red; 
extern bool   verticalLinesVisible     = false;
extern string verticalLinesID          = "wpr lines1";
extern color  verticalLinesUpColor     = DeepSkyBlue;
extern color  verticalLinesDownColor   = PaleVioletRed;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;

extern bool   alertsOn                 = true;
extern bool   alertsOnFiftyCross       = false;
extern bool   alertsOnLeavingObOs      = true;
extern bool   alertsOnCurrent          = true;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsNotify             = false;
extern bool   alertsEmail              = false;

extern bool   arrowsVisible            = true;
extern string arrowsIdentifier         = "wpr arrows1";
extern double arrowsUpperGap           = 1.0;
extern double arrowsLowerGap           = 1.0;

extern bool   arrowsOnFiftyCross       = true;
extern color  arrowsOnFiftyCrossUpColor= LimeGreen;
extern color  arrowsOnFiftyCrossDnColor= Red;
extern int    arrowsOnFiftyCrossUpCode = 241;
extern int    arrowsOnFiftyCrossDnCode = 242;
extern int    arrowsOnFiftyCrossSize   = 2;

extern bool   arrowsOnLeavingObOs      = true;
extern color  arrowsLeavingObOsUpColor = DodgerBlue;
extern color  arrowsLeavingObOsDnColor = OrangeRed;
extern int    arrowsLeavingObOsUpCode  = 241;
extern int    arrowsLeavingObOsDnCode  = 242;
extern int    arrowsLeavingObOsSize    = 3;

//
//
//
//
//

double wpr[];
double wprUpa[];
double wprUpb[];
double wprDna[];
double wprDnb[];
double value[];
double trend1[];
double trend2[];

//
//
//
//
//

int init()
  {
   IndicatorBuffers(8);
   SetIndexBuffer(0,wpr);
   SetIndexBuffer(1,wprUpa); SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,OverSoldColor);
   SetIndexBuffer(2,wprUpb); SetIndexStyle(2,DRAW_LINE,EMPTY,EMPTY,OverSoldColor);
   SetIndexBuffer(3,wprDna); SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,OverBoughtColor);
   SetIndexBuffer(4,wprDnb); SetIndexStyle(4,DRAW_LINE,EMPTY,EMPTY,OverBoughtColor);
   SetIndexBuffer(5,value);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,-50);
   IndicatorShortName( " %R ("+WprPeriod+")");
return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   deleteArrows();
return(0);
}
  
//+------------------------------------------------------------------+
//| Williams? Percent Range                                          |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //
   
   if (MultiColored && value[limit]== 1) CleanPoint(limit,wprUpa,wprUpb);
   if (MultiColored && value[limit]==-1) CleanPoint(limit,wprDna,wprDnb);       
   for (i=limit; i>=0; i--)
   {
       double hi   = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
       double lo   =  Low[iLowest(NULL, 0,MODE_LOW, WprPeriod,i)];
       if (hi!=lo)      
            wpr[i] = -100*(hi - Close[i]) / (hi - lo);
       else wpr[i] = 0;
       
       //
       //
       //
       //
       //
       
       wprUpa[i] = EMPTY_VALUE;
       wprUpb[i] = EMPTY_VALUE;
       wprDna[i] = EMPTY_VALUE;
       wprDnb[i] = EMPTY_VALUE;
       value[i]  = value[i+1];
       trend1[i] = 0;
       trend2[i] = trend2[i+1];
       
          if (wpr[i]>levelOs && wpr[i]<levelOb) value[i]  = 0;
          if (wpr[i]>levelOb)                   value[i]  =-1;
          if (wpr[i]<levelOs)                   value[i]  = 1;
          if (wpr[i]>levelOb)                   trend1[i] = 1;
          if (wpr[i]<levelOs)                   trend1[i] =-1;
          if (wpr[i]>-50)                       trend2[i] = 1;
          if (wpr[i]<-50)                       trend2[i] =-1;
          if (MultiColored && value[i] ==  1)   PlotPoint(i,wprUpa,wprUpb,wpr);
          if (MultiColored && value[i] == -1)   PlotPoint(i,wprDna,wprDnb,wpr);
          manageLines(i);
          manageArrow(i);
   }
   manageAlerts();
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageLines(int i)
{
   if (verticalLinesVisible )
   {
         deleteLine(Time[i]);
         if (trend1[i]!=trend1[i+1])
         {
            if (trend1[i+1] == -1 && trend1[i] !=-1) drawLine(i,verticalLinesUpColor);
            if (trend1[i+1] ==  1 && trend1[i] != 1) drawLine(i,verticalLinesDownColor);
         }
   }
}               

//
//
//
//
//

void drawLine(int i,color theColor)
{
    string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void deleteLine(datetime time)
{
    string lookFor = verticalLinesID+":"+time; ObjectDelete(lookFor);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnLeavingObOs && trend1[i] != trend1[i+1])
      {
         if (trend1[i+1] == -1 && trend1[i] !=-1) drawArrow("2",0.5,i,arrowsLeavingObOsUpColor,arrowsLeavingObOsUpCode,arrowsLeavingObOsSize,false);
         if (trend1[i+1] ==  1 && trend1[i] != 1) drawArrow("2",0.5,i,arrowsLeavingObOsDnColor,arrowsLeavingObOsDnCode,arrowsLeavingObOsSize, true);
      }
      if (arrowsOnFiftyCross && trend2[i] != trend2[i+1])
      {
         if (trend2[i] == 1) drawArrow("1",1,i,arrowsOnFiftyCrossUpColor,arrowsOnFiftyCrossUpCode,arrowsOnFiftyCrossSize,false);
         if (trend2[i] ==-1) drawArrow("1",1,i,arrowsOnFiftyCrossDnColor,arrowsOnFiftyCrossDnCode,arrowsOnFiftyCrossSize, true);
      }                                   
   }         
}       

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,int theWidth,bool up)
{
    string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
    double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnLeavingObOs && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar+1] == -1 && trend1[whichBar] !=-1) doAlert(time1,mess1,whichBar," Wpr leaving oversold zone");
            if (trend1[whichBar+1] ==  1 && trend1[whichBar] != 1) doAlert(time1,mess1,whichBar," Wpr leaving overbought zone");
         } 
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnFiftyCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," Wpr crossed -50 up ");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," Wpr crossed -50 down");
         }                                  
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol(),TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Wpr " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Wpr "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


